Index: /LMDZ4/trunk/libf/phylmd/interface_surf.F90
===================================================================
--- /LMDZ4/trunk/libf/phylmd/interface_surf.F90	(revision 765)
+++ /LMDZ4/trunk/libf/phylmd/interface_surf.F90	(revision 766)
@@ -22,5 +22,5 @@
 ! L. Fairhead, LMD, 02/2000
 
-  USE ioipsl
+!ym  USE ioipsl
 
   IMPLICIT none
@@ -44,13 +44,21 @@
 ! run_off      ruissellement total
   REAL, ALLOCATABLE, DIMENSION(:),SAVE    :: run_off, run_off_lic
+!$OMP THREADPRIVATE(run_off, run_off_lic)
   real, allocatable, dimension(:),save    :: coastalflow, riverflow
+!$OMP THREADPRIVATE(coastalflow, riverflow)
 !!$PB
   REAL, ALLOCATABLE, DIMENSION(:,:), SAVE :: tmp_rriv, tmp_rcoa,tmp_rlic
+!$OMP THREADPRIVATE(tmp_rriv, tmp_rcoa,tmp_rlic)
 !! pour simuler la fonte des glaciers antarctiques
   REAL, ALLOCATABLE, DIMENSION(:,:), SAVE :: coeff_iceberg
+!$OMP THREADPRIVATE(coeff_iceberg)
   real, save                              :: surf_maille 
+!$OMP THREADPRIVATE(surf_maille)
   real, save                              :: cte_flux_iceberg = 6.3e7
+!$OMP THREADPRIVATE(cte_flux_iceberg)  
   integer, save                           :: num_antarctic = 1
+!$OMP THREADPRIVATE(num_antarctic)
   REAL, save                              :: tau_calv
+!$OMP THREADPRIVATE(tau_calv)
 !!$
   CONTAINS
@@ -75,9 +83,10 @@
       & evap, fluxsens, fluxlat, dflux_l, dflux_s, &              
       & tsol_rad, tsurf_new, alb_new, alblw, emis_new, &
-      & z0_new, pctsrf_new, agesno,fqcalving,ffonte, run_off_lic_0,&
+      & z0_new, pctsrf_new, agesno,fqcalving,fqfonte,ffonte, run_off_lic_0,&
 !IM "slab" ocean
       & flux_o, flux_g, tslab, seaice)
 
 
+   USE dimphy,only : monocpu,jjphy_nb,omp_rank
 ! Cette routine sert d'aiguillage entre l'atmosphere et la surface en general 
 ! (sols continentaux, oceans, glaces) pour les fluxs de chaleur et d'humidite.
@@ -189,8 +198,11 @@
   real, dimension(klon), intent(INOUT) :: tslab
   real, allocatable, dimension(:), save :: tmp_tslab
+!$OMP THREADPRIVATE(tmp_tslab)
   real, dimension(klon), intent(OUT) :: flux_o, flux_g
   real, dimension(klon), intent(INOUT)        :: seaice ! glace de mer (kg/m2)
   real, dimension(klon)                       :: siceh  ! hauteur glace de mer (m)
   REAL, DIMENSION(klon), INTENT(INOUT) :: radsol,fder
+  
+!  real, dimension(klon), intent(IN) :: zmasq
   real, dimension(klon), intent(IN) :: zmasq
   real, dimension(klon), intent(IN) :: taux, tauy, rugos, rugoro
@@ -221,8 +233,8 @@
 !jld a rajouter   real, dimension(klon), intent(INOUT):: ffonte
   real, dimension(klon), intent(INOUT):: ffonte
-! Flux d'eau "perdue" par la surface et nécessaire pour que limiter la
-! hauteur de neige, en kg/m2/s
-!jld a rajouter   real, dimension(klon), intent(INOUT):: fqcalving
-  real, dimension(klon), intent(INOUT):: fqcalving
+! Flux d'eau "perdue" par la surface et necessaire pour que limiter la
+! hauteur de neige, en kg/m2/s. Et quantite d'eau de fonte de la calotte.
+!jld a rajouter   real, dimension(klon), intent(INOUT):: fqcalving, fqfonte
+  REAL, DIMENSION(klon), INTENT(INOUT):: fqcalving, fqfonte
 !IM: "slab" ocean
   real, dimension(klon) :: new_dif_grnd 
@@ -232,15 +244,22 @@
   integer i
   real, allocatable, dimension(:), save :: tmp_flux_o, tmp_flux_g
+!$OMP THREADPRIVATE(tmp_flux_o, tmp_flux_g)  
   real, allocatable, dimension(:), save :: tmp_radsol
+!$OMP THREADPRIVATE(tmp_radsol)
   real, allocatable, dimension(:,:), save :: tmp_pctsrf_slab
+!$OMP THREADPRIVATE(tmp_pctsrf_slab)
   real, allocatable, dimension(:), save :: tmp_seaice
-
+!$OMP THREADPRIVATE(tmp_seaice)
 ! Local
   character (len = 20),save :: modname = 'interfsurf_hq'
+!$OMP THREADPRIVATE(modname)
   character (len = 80) :: abort_message 
   logical, save        :: first_call = .true.
+!$OMP THREADPRIVATE(first_call)  
   integer, save        :: error
+!$OMP THREADPRIVATE(error)  
   integer              :: ii, index
-  logical,save              :: check = .false.
+  logical,save              :: check = .true.
+!$OMP THREADPRIVATE(check)  
   real, dimension(klon):: cal, beta, dif_grnd, capsol
 !!$PB  real, parameter      :: calice=1.0/(5.1444e+06*0.15), tau_gl=86400.*5.
@@ -258,4 +277,6 @@
   real, dimension(klon):: fder_prev
   REAL, dimension(klon) :: bidule
+  real, dimension(klon) :: ps_tmp,p1lay_tmp
+  INTEGER :: j
 !
 !IM ?? quelques variables pour netcdf
@@ -295,8 +316,19 @@
 !      call abort_gcm(modname,abort_message,1)
 !    endif
+  endif
+  first_call = .false.
+  
+! Initialisations diverses
+!
+!!$  cal=0.; beta=1.; dif_grnd=0.; capsol=0.
+!!$  alb_new = 0.; z0_new = 0.; alb_neig = 0.0
+!!$! PB
+!!$  tsurf_new = 0.
 
 !IM cf JLD
   ffonte(1:knon)=0.
   fqcalving(1:knon)=0.
+  fqfonte  (1:knon)=0.
+
 
   cal = 999999. ; beta = 999999. ; dif_grnd = 999999. ; capsol = 999999.
@@ -368,14 +400,4 @@
      tmp_tslab(i)=tslab(i)
     ENDDO
-  endif
-  first_call = .false.
-  
-! Initialisations diverses
-!
-!!$  cal=0.; beta=1.; dif_grnd=0.; capsol=0.
-!!$  alb_new = 0.; z0_new = 0.; alb_neig = 0.0
-!!$! PB
-!!$  tsurf_new = 0.
-
 !
 ! Aiguillage vers les differents schemas de surface
@@ -407,23 +429,23 @@
 
 !!$PB
-      ALLOCATE (tmp_rriv(iim,jjm+1), stat=error)
+      ALLOCATE (tmp_rriv(iim,jjphy_nb), stat=error)
       if (error /= 0) then
         abort_message='Pb allocation tmp_rriv'
         call abort_gcm(modname,abort_message,1)
       endif
-      ALLOCATE (tmp_rcoa(iim,jjm+1), stat=error)
+      tmp_rriv=0.
+      ALLOCATE (tmp_rcoa(iim,jjphy_nb), stat=error)
       if (error /= 0) then
         abort_message='Pb allocation tmp_rcoa'
         call abort_gcm(modname,abort_message,1)
       endif
-      ALLOCATE (tmp_rlic(iim,jjm+1), stat=error)
+      tmp_rcoa=0.
+!ym      ALLOCATE (tmp_rlic(iim,jjm+1), stat=error)
+      ALLOCATE (tmp_rlic(iim,jjphy_nb), stat=error)
       if (error /= 0) then
         abort_message='Pb allocation tmp_rlic'
         call abort_gcm(modname,abort_message,1)
       endif
-      tmp_rriv = 0.0
-      tmp_rcoa = 0.0
-      tmp_rlic = 0.0
-
+      tmp_rlic=0.
 !!$
     else if (size(coastalflow) /= knon) then
@@ -449,6 +471,5 @@
      & alb_new, z0_new)
 !  
-! calcul snow et qsurf, hydrol adapté
-!
+! calcul snow et qsurf, hydrol adapte !
        CALL calbeta(dtime, nisurf, knon, snow, qsol, beta, capsol, dif_grnd)
 
@@ -474,5 +495,5 @@
      &   petAcoef, peqAcoef, petBcoef, peqBcoef, &
      &   tsurf_new, evap, fluxlat, fluxsens, dflux_s, dflux_l, &
-     &   fqcalving,ffonte, run_off_lic_0)
+     &   fqcalving,fqfonte,ffonte, run_off_lic_0)
 
 
@@ -491,5 +512,8 @@
 !
 #ifdef CPP_VEGET
-      call interfsol(itime, klon, dtime, date0, nisurf, knon, &
+      p1lay_tmp(1:knon)=p1lay(1:knon)/100.
+      ps_tmp(1:knon)=ps(1:knon)/100.
+ 
+       call interfsol(itime, klon, dtime, date0, nisurf, knon, &
      &  knindex, rlon, rlat, cufi, cvfi, iim, jjm, pctsrf, &
      &  debut, lafin, ok_veget, &
@@ -497,5 +521,5 @@
      &  tq_cdrag, petAcoef, peqAcoef, petBcoef, peqBcoef, &
      &  precip_rain, precip_snow, sollwdown, swnet, swdown, &
-     &  tsurf, p1lay/100., ps/100., radsol, &
+     &  tsurf, p1lay_tmp, ps_tmp, radsol, &
      &  evap, fluxsens, fluxlat, &              
      &  tsol_rad, tsurf_new, alb_new, alblw, &
@@ -779,5 +803,5 @@
              &   petAcoef, peqAcoef, petBcoef, peqBcoef, &
              &   tsurf_new, evap, fluxlat, fluxsens, dflux_s, dflux_l, &
-             &   fqcalving,ffonte, run_off_lic_0)
+             &   fqcalving,fqfonte,ffonte, run_off_lic_0)
 
 !     calcul albedo
@@ -893,5 +917,5 @@
 
     if (.not. allocated(run_off_lic)) then
-      allocate(run_off_lic(knon), stat = error)
+      allocate(run_off_lic(klon), stat = error)
       if (error /= 0) then
         abort_message='Pb allocation run_off_lic'
@@ -928,5 +952,5 @@
      &   petAcoef, peqAcoef, petBcoef, peqBcoef, &
      &   tsurf_new, evap, fluxlat, fluxsens, dflux_s, dflux_l, &
-     &   fqcalving,ffonte, run_off_lic_0)
+     &   fqcalving,fqfonte,ffonte, run_off_lic_0)
 
 ! passage du run-off des glaciers calcule dans fonte_neige au coupleur
@@ -1010,5 +1034,6 @@
 
   USE intersurf
-
+  USE dimphy, klon_x=>klon
+  IMPLICIT NONE
 ! Cette routine sert d'interface entre le modele atmospherique et le 
 ! modele de sol continental. Appel a sechiba
@@ -1128,6 +1153,5 @@
 ! offset pour calculer les point voisins
   integer, dimension(8,3), save :: off_ini
-  integer, dimension(8), save :: offset
-! Identifieurs des fichiers restart et histoire
+ ! Identifieurs des fichiers restart et histoire
   integer, save          :: rest_id, hist_id 
   integer, save          :: rest_id_stom, hist_id_stom
@@ -1145,9 +1169,12 @@
   integer, dimension(:), save, allocatable :: ig, jg
   integer :: indi, indj
-  integer, dimension(klon) :: ktindex
+  integer, save, allocatable,dimension(:) :: ktindex
   REAL, dimension(klon) :: bidule
 ! Essai cdrag
   real, dimension(klon) :: cdrag
-
+  integer :: jjb,jje,ijb,ije
+  INTEGER,SAVE :: offset
+  REAL, dimension(klon2) :: rlon_g,rlat_g
+  INTEGER, SAVE          :: orch_comm
 #include "temps.inc"
 #include "YOMCST.inc"
@@ -1157,9 +1184,10 @@
   if (check) write(lunout,*)'ok_veget = ',ok_veget
 
-  ktindex(:) = knindex(:) + iim - 1
-
+
+  
 ! initialisation
+  
   if (debut) then
-
+    ALLOCATE(ktindex(klon))
   IF ( .NOT. allocated(albedo_keep)) THEN
      ALLOCATE(albedo_keep(klon))
@@ -1184,41 +1212,5 @@
    ig(klon) = 1
    jg(klon) = jjm + 1
-!
-!  Initialisation des offset    
-!
-! offset bord ouest
-   off_ini(1,1) = - iim  ; off_ini(2,1) = - iim + 1; off_ini(3,1) = 1
-   off_ini(4,1) = iim + 1; off_ini(5,1) = iim      ; off_ini(6,1) = 2 * iim - 1
-   off_ini(7,1) = iim -1 ; off_ini(8,1) = - 1
-! offset point normal
-   off_ini(1,2) = - iim  ; off_ini(2,2) = - iim + 1; off_ini(3,2) = 1
-   off_ini(4,2) = iim + 1; off_ini(5,2) = iim      ; off_ini(6,2) = iim - 1
-   off_ini(7,2) = -1     ; off_ini(8,2) = - iim - 1
-! offset bord   est
-   off_ini(1,3) = - iim; off_ini(2,3) = - 2 * iim + 1; off_ini(3,3) = - iim + 1
-   off_ini(4,3) =  1   ; off_ini(5,3) = iim          ; off_ini(6,3) = iim - 1
-   off_ini(7,3) = -1   ; off_ini(8,3) = - iim - 1
-!
-! Initialisation des correspondances point -> indices i,j
-!
-    if (( .not. allocated(correspond))) then
-      allocate(correspond(iim,jjm+1), stat = error)
-      if (error /= 0) then
-        abort_message='Pb allocation correspond'
-        call abort_gcm(modname,abort_message,1)
-      endif      
-    endif
-!
-! Attention aux poles
-!
-    do igrid = 1, knon
-      index = ktindex(igrid)
-          jj = int((index - 1)/iim) + 1
-          ij = index - (jj - 1) * iim
-      correspond(ij,jj) = igrid
-    enddo
-
-! Allouer et initialiser le tableau de coordonnees du sol
-!
+
     if ((.not. allocated(lalo))) then
       allocate(lalo(knon,2), stat = error)
@@ -1248,33 +1240,27 @@
       lalo(igrid,2) = rlon(index)
       lalo(igrid,1) = rlat(index)
-      ij = index - int((index-1)/iim)*iim - 1
-      jj = 2 + int((index-1)/iim)
-      if (mod(index,iim) == 1 ) then
-        jj = 1 + int((index-1)/iim)
-        ij = iim
-      endif
-!      lon_scat(ij,jj) = rlon(index)
-!      lat_scat(ij,jj) = rlat(index)
+
     enddo
-    index = 1
-    do jj = 2, jjm
-      do ij = 1, iim
-        index = index + 1
-        lon_scat(ij,jj) = rlon(index)
-        lat_scat(ij,jj) = rlat(index)
+   
+
+    
+    Call GatherField(rlon,rlon_g,1)
+    Call GatherField(rlat,rlat_g,1)
+
+    IF (phy_rank==0) THEN
+      index = 1
+      do jj = 2, jjm
+        do ij = 1, iim
+          index = index + 1
+          lon_scat(ij,jj) = rlon_g(index)
+          lat_scat(ij,jj) = rlat_g(index)
+        enddo
       enddo
-    enddo
-    lon_scat(:,1) = lon_scat(:,2)
-    lat_scat(:,1) = rlat(1)
-    lon_scat(:,jjm+1) = lon_scat(:,2)
-    lat_scat(:,jjm+1) = rlat(klon)
-! Pb de correspondances de grilles!
-!    do igrid = 1, knon
-!      index = ktindex(igrid)
-!      ij = ig(index)
-!      jj = jg(index)
-!      lon_scat(ij,jj) = rlon(index)
-!      lat_scat(ij,jj) = rlat(index)
-!    enddo
+     lon_scat(:,1) = lon_scat(:,2)
+     lat_scat(:,1) = rlat_g(1)
+     lon_scat(:,jjm+1) = lon_scat(:,2)
+     lat_scat(:,jjm+1) = rlat_g(klon2)
+   ENDIF
+   
 
 !
@@ -1302,23 +1288,6 @@
     enddo
 
-    do igrid = 1, knon
-      iglob = ktindex(igrid)
-      if (mod(iglob, iim) == 1) then
-        offset = off_ini(:,1)
-      else if(mod(iglob, iim) == 0) then
-        offset = off_ini(:,3)
-      else
-        offset = off_ini(:,2)
-      endif 
-      do i = 1, 8
-        index = iglob + offset(i)
-        ireal = (min(max(1, index - iim + 1), klon))
-        if (pctsrf(ireal, is_ter) > EPSFRA) then
-          jj = int((index - 1)/iim) + 1
-          ij = index - (jj - 1) * iim
-            neighbours(igrid, i) = correspond(ij, jj)
-        endif
-      enddo
-    enddo
+
+   CALL Init_neighbours(iim,jjm,knon,neighbours,knindex,pctsrf(:,is_ter))
 
 !
@@ -1336,10 +1305,4 @@
       resolution(igrid,2) = cvfi(ij)
     enddo  
-!IM tester la resolution que recoit Orchidee
-    IF((maxval(resolution(:,2)) == 0.).OR. &
-   &   (maxval(resolution(:,1)) == 0.)) THEN
-     abort_message='STOP interfsol : resolution recue par Orchidee = 0.'
-     call abort_gcm(modname,abort_message,1)
-    ENDIF
 
   endif                          ! (fin debut) 
@@ -1374,15 +1337,32 @@
 ! Init Orchidee
 !
+!  if (pole_nord) then 
+!    offset=0
+!    ktindex(:)=ktindex(:)+iim-1
+!  else
+!    offset = klon_begin-1+iim-1
+!    ktindex(:)=ktindex(:)+MOD(offset,iim)
+!    offset=offset-MOD(offset,iim)
+!  endif
+  
+  PRINT *,'ORCHIDEE ------> KNON : ',knon
+  
+   
   if (debut) then
-    call intersurf_main (itime+itau_phy-1, iim, jjm+1, knon, ktindex, dtime, &
-     & lrestart_read, lrestart_write, lalo, &
-     & contfrac, neighbours, resolution, date0, &
-     & zlev,  u1_lay, v1_lay, spechum, temp_air, epot_air, ccanopy, &
-     & cdrag, petA_orc, peqA_orc, petB_orc, peqB_orc, &
-     & precip_rain, precip_snow, lwdown, swnet, swdown, ps, &
-     & evap, fluxsens, fluxlat, coastalflow, riverflow, &
-     & tsol_rad, tsurf_new, qsurf, albedo_out, emis_new, z0_new, &
-     & lon_scat, lat_scat)
-
+    CALL Get_orchidee_communicator(knon,orch_comm)
+    IF (knon /=0) THEN
+      CALL Init_orchidee_index(iim,knon,orch_comm,knindex,offset,ktindex)
+    
+      call intersurf_main (itime+itau_phy-1, iim, jjm+1,offset, knon, ktindex, & 
+       & orch_comm,dtime, lrestart_read, lrestart_write, lalo, &
+       & contfrac, neighbours, resolution, date0, &
+       & zlev,  u1_lay, v1_lay, spechum, temp_air, epot_air, ccanopy, &
+       & cdrag, petA_orc, peqA_orc, petB_orc, peqB_orc, &
+       & precip_rain, precip_snow, lwdown, swnet, swdown, ps, &
+       & evap, fluxsens, fluxlat, coastalflow, riverflow, &
+       & tsol_rad, tsurf_new, qsurf, albedo_out, emis_new, z0_new, &
+       & lon_scat, lat_scat)
+
+     ENDIF
 !IM cf. JP +++
     albedo_keep(1:knon) = (albedo_out(1:knon,1)+albedo_out(1:knon,2))/2.
@@ -1392,19 +1372,21 @@
 
 !IM cf. JP +++
-!IM swdown_vrai(1:knon) = swnet(1:knon)/(1. - albedo_keep(1:knon))
-!IM modification faite dans clmain
-    swdown_vrai(1:knon) = swdown(1:knon)
+!  swdown_vrai(1:knon) = swnet(1:knon)/(1. - albedo_keep(1:knon))
+  swdown_vrai(1:knon) = swdown(1:knon)
+
 !IM cf. JP ---
-
-  call intersurf_main (itime+itau_phy, iim, jjm+1, knon, ktindex, dtime, &
-     & lrestart_read, lrestart_write, lalo, &
-     & contfrac, neighbours, resolution, date0, &
-     & zlev,  u1_lay, v1_lay, spechum, temp_air, epot_air, ccanopy, &
-     & cdrag, petA_orc, peqA_orc, petB_orc, peqB_orc, &
-     & precip_rain, precip_snow, lwdown, swnet, swdown_vrai, ps, &
-     & evap, fluxsens, fluxlat, coastalflow, riverflow, &
-     & tsol_rad, tsurf_new, qsurf, albedo_out, emis_new, z0_new, &
-     & lon_scat, lat_scat)
-
+    IF (knon /=0) THEN
+    
+      call intersurf_main (itime+itau_phy, iim, jjm+1,offset, knon, ktindex, & 
+       & orch_comm,dtime, lrestart_read, lrestart_write, lalo, &
+       & contfrac, neighbours, resolution, date0, &
+       & zlev,  u1_lay, v1_lay, spechum, temp_air, epot_air, ccanopy, &
+       & cdrag, petA_orc, peqA_orc, petB_orc, peqB_orc, &
+       & precip_rain, precip_snow, lwdown, swnet, swdown_vrai, ps, &
+       & evap, fluxsens, fluxlat, coastalflow, riverflow, &
+       & tsol_rad, tsurf_new, qsurf, albedo_out, emis_new, z0_new, &
+       & lon_scat, lat_scat)
+
+    ENDIF
 !IM cf. JP +++
     albedo_keep(1:knon) = (albedo_out(1:knon,1)+albedo_out(1:knon,2))/2.
@@ -1413,8 +1395,8 @@
     bidule=0.
     bidule(1:knon)=riverflow(1:knon)
-    call gath2cpl(bidule, tmp_rriv, klon, knon,iim,jjm,knindex)
+    call gath2cpl(bidule, tmp_rriv, klon, knon,iim,jjphy_nb,knindex)
     bidule=0.
     bidule(1:knon)=coastalflow(1:knon)
-    call gath2cpl(bidule, tmp_rcoa, klon, knon,iim,jjm,knindex)
+    call gath2cpl(bidule, tmp_rcoa, klon, knon,iim,jjphy_nb,knindex)
     alb_new(1:knon) = albedo_out(1:knon,1) 
     alblw(1:knon) = albedo_out(1:knon,2)
@@ -1430,4 +1412,217 @@
 
   END SUBROUTINE interfsol
+  
+  SUBROUTINE Init_orchidee_index(iim,knon,orch_comm,knindex,offset,ktindex)
+  USE dimphy
+  IMPLICIT NONE
+    INTEGER,INTENT(IN)  :: iim
+    INTEGER,INTENT(IN)  :: knon
+    INTEGER,INTENT(IN)  :: orch_comm
+    INTEGER,INTENT(IN)  :: knindex(knon)
+    INTEGER,INTENT(OUT) :: offset
+    INTEGER,INTENT(OUT) :: ktindex(knon)
+
+#ifdef CPP_PARA
+    INCLUDE 'mpif.h'
+    INTEGER :: status(MPI_STATUS_SIZE)
+#endif
+    INTEGER :: MyLastPoint
+    INTEGER :: LastPoint
+    INTEGER :: mpi_rank
+    INTEGER :: mpi_size
+    INTEGER :: ierr   
+    
+    MyLastPoint=klon_begin-1+knindex(knon)+iim-1
+
+    IF (.NOT. monocpu) THEN
+#ifdef CPP_PARA    
+      call MPI_COMM_SIZE(orch_comm,mpi_size,ierr)
+      call MPI_COMM_RANK(orch_comm,mpi_rank,ierr)
+#endif
+    ELSE
+      mpi_rank=0
+      mpi_size=1
+    ENDIF
+    
+    IF (.NOT. monocpu) THEN
+      IF (mpi_rank /= 0) then
+#ifdef CPP_PARA
+        CALL MPI_RECV(LastPoint,1,MPI_INTEGER,mpi_rank-1,1234,orch_comm,status,ierr)
+#endif
+      ENDIF
+        
+      IF (mpi_rank /= mpi_size-1) THEN
+#ifdef CPP_PARA
+        CALL MPI_SEND(MyLastPoint,1,MPI_INTEGER,mpi_rank+1,1234,orch_comm,ierr)  
+#endif
+      ENDIF
+    ENDIF
+    
+    IF (mpi_rank==0) THEN 
+      offset=0
+    ELSE
+     offset=LastPoint-MOD(LastPoint,iim)
+    ENDIF
+     
+    ktindex(:)=knindex(:)+(klon_begin+iim-1)-offset-1	
+    
+
+   END SUBROUTINE  Init_orchidee_index 
+
+  
+  SUBROUTINE Get_orchidee_communicator(knon,orch_comm)
+  USE dimphy, only : phy_rank
+#ifdef CPP_PARA
+  USE parallel, only : COMM_LMDZ
+#endif
+  IMPLICIT NONE
+#ifdef CPP_PARA
+    include 'mpif.h'
+#endif    
+    INTEGER,INTENT(IN)  :: knon
+    INTEGER,INTENT(OUT) :: orch_comm
+    
+    INTEGER :: color
+    INTEGER :: ierr
+    
+    IF (knon==0) THEN 
+      color = 0
+    ELSE 
+      color = 1
+    ENDIF
+
+#ifdef CPP_PARA    
+    CALL MPI_COMM_SPLIT(COMM_LMDZ,color,phy_rank,orch_comm,ierr)
+#endif
+    
+  END SUBROUTINE Get_orchidee_communicator 
+    
+    
+  SUBROUTINE Init_neighbours(iim,jjm,knon,neighbours,ktindex,pctsrf)
+#ifdef CPP_PARA
+  USE parallel,only : COMM_LMDZ
+#endif
+  USE dimphy
+  IMPLICIT NONE
+#ifdef CPP_PARA
+  include 'mpif.h'
+#endif
+  INTEGER :: iim,jjm
+  INTEGER :: knon
+  INTEGER :: neighbours(knon,8)
+  INTEGER :: ktindex(knon)
+  REAL :: pctsrf(klon)
+  
+  INTEGER :: knon_nb(0:phy_size-1)
+  INTEGER,DIMENSION(0:phy_size-1) :: displs,sendcount
+  INTEGER,ALLOCATABLE :: ktindex_g(:)
+  REAL*8  :: pctsrf_g(klon2)
+  INTEGER,ALLOCATABLE ::neighbours_g(:,:)
+  INTEGER :: knon_g
+  REAL*8 :: correspond(iim,jjm+1)
+  INTEGER :: i,igrid,jj,ij,iglob,ierr,ireal,index
+  integer, dimension(8,3) :: off_ini
+  integer, dimension(8)   :: offset  
+  INTEGER :: ktindex_p(knon)
+
+  IF (monocpu) THEN
+    knon_nb(:)=knon
+  ELSE  
+
+#ifdef CPP_PARA  
+    CALL MPI_GATHER(knon,1,MPI_INTEGER,knon_nb,1,MPI_INTEGER,0,COMM_LMDZ,ierr)
+#endif
+  
+  ENDIF
+    
+  IF (phy_rank==0) THEN
+    knon_g=sum(knon_nb(:))
+    ALLOCATE(ktindex_g(knon_g))
+    ALLOCATE(neighbours_g(knon_g,8))
+    neighbours_g(:,:)=-1
+    displs(0)=0
+    DO i=1,phy_size-1
+      displs(i)=displs(i-1)+knon_nb(i-1)
+    ENDDO  
+  ENDIF
+  
+  ktindex_p(:)=ktindex(:)+klon_begin-1+iim-1
+
+  IF (monocpu) THEN
+    ktindex_g(:)=ktindex_p(:)
+  ELSE
+
+#ifdef CPP_PARA  
+    CALL MPI_GATHERV(ktindex_p,knon,MPI_INTEGER,ktindex_g,knon_nb,displs,MPI_INTEGER,0,COMM_LMDZ,ierr)
+#endif
+
+  ENDIF
+     
+  CALL GatherField(pctsrf,pctsrf_g,1)
+  
+  IF (phy_rank==0) THEN
+!  Initialisation des offset    
+!
+! offset bord ouest
+   off_ini(1,1) = - iim  ; off_ini(2,1) = - iim + 1; off_ini(3,1) = 1
+   off_ini(4,1) = iim + 1; off_ini(5,1) = iim      ; off_ini(6,1) = 2 * iim - 1
+   off_ini(7,1) = iim -1 ; off_ini(8,1) = - 1
+! offset point normal
+   off_ini(1,2) = - iim  ; off_ini(2,2) = - iim + 1; off_ini(3,2) = 1
+   off_ini(4,2) = iim + 1; off_ini(5,2) = iim      ; off_ini(6,2) = iim - 1
+   off_ini(7,2) = -1     ; off_ini(8,2) = - iim - 1
+! offset bord   est
+   off_ini(1,3) = - iim; off_ini(2,3) = - 2 * iim + 1; off_ini(3,3) = - iim + 1
+   off_ini(4,3) =  1   ; off_ini(5,3) = iim          ; off_ini(6,3) = iim - 1
+   off_ini(7,3) = -1   ; off_ini(8,3) = - iim - 1
+!
+!
+! Attention aux poles
+!
+    do igrid = 1, knon_g
+      index = ktindex_g(igrid)
+          jj = int((index - 1)/iim) + 1
+          ij = index - (jj - 1) * iim
+      correspond(ij,jj) = igrid
+    enddo
+
+    do igrid = 1, knon_g
+      iglob = ktindex_g(igrid)
+      if (mod(iglob, iim) == 1) then
+        offset = off_ini(:,1)
+      else if(mod(iglob, iim) == 0) then
+        offset = off_ini(:,3)
+      else
+        offset = off_ini(:,2)
+      endif 
+      do i = 1, 8
+        index = iglob + offset(i)
+        ireal = (min(max(1, index - iim + 1), klon2))
+        if (pctsrf_g(ireal) > EPSFRA) then
+          jj = int((index - 1)/iim) + 1
+          ij = index - (jj - 1) * iim
+            neighbours_g(igrid, i) = correspond(ij, jj)
+        endif
+      enddo
+    enddo
+
+!    DO i=0,phy_size-1
+!      displs(i)=displs(i)*8
+!      sendcount(i)=knon_nb(i)*8
+!    ENDDO
+  
+  ENDIF
+  
+  DO i=1,8
+    IF (monocpu) THEN
+      neighbours(:,i)=neighbours_g(:,i)
+    ELSE
+#ifdef CPP_PARA
+    CALL MPI_SCATTERV(neighbours_g(:,i),knon_nb,displs,MPI_INTEGER,neighbours(:,i),knon,MPI_INTEGER,0,COMM_LMDZ,ierr) 
+#endif
+    ENDIF
+  ENDDO
+  
+  END SUBROUTINE Init_neighbours
 #endif
 !
@@ -1446,4 +1641,17 @@
       & pctsrf_new)
 
+   USE ioipsl
+   USE dimphy, only : jjphy_nb, iiphy_begin,iiphy_end,phy_rank,phy_size, monocpu
+   USE iophy
+#ifdef CPP_PARA
+   USE parallel, only: pole_nord,pole_sud,COMM_LMDZ
+#endif
+#ifdef CPP_PSMILE
+   USE oasis
+#endif
+   USE write_field_phy
+   implicit none
+#include "indicesol.inc"
+#include "YOMCST.inc"
 ! Cette routine sert d'interface entre le modele atmospherique et un 
 ! coupleur avec un modele d'ocean 'complet' derriere
@@ -1500,8 +1708,5 @@
 !   alb_ice      albedo de la glace
 !
-#ifdef CPP_PSMILE  
-  USE oasis
-  integer :: il_time_secs !time in seconds
-#endif
+
 
 ! Parametres d'entree
@@ -1561,14 +1766,21 @@
   REAL, ALLOCATABLE, DIMENSION(:,:,:),SAVE :: tmp_tauy
 ! variables a passer au coupleur
-  real, dimension(iim, jjm+1) :: wri_sol_ice, wri_sol_sea, wri_nsol_ice 
-  real, dimension(iim, jjm+1) :: wri_nsol_sea, wri_fder_ice, wri_evap_ice
-  REAL, DIMENSION(iim, jjm+1) :: wri_evap_sea, wri_rcoa, wri_rriv
-  REAL, DIMENSION(iim, jjm+1) :: wri_rain, wri_snow, wri_taux, wri_tauy
-! -- LOOP
-   REAL, DIMENSION(iim, jjm+1) :: wri_windsp
-! -- LOOP
-  REAL, DIMENSION(iim, jjm+1) :: wri_calv
-  REAL, DIMENSION(iim, jjm+1) :: wri_tauxx, wri_tauyy, wri_tauzz
-  REAL, DIMENSION(iim, jjm+1) :: tmp_lon, tmp_lat
+!ym  real, dimension(iim, jjm+1) :: wri_sol_ice, wri_sol_sea, wri_nsol_ice 
+!ym  real, dimension(iim, jjm+1) :: wri_nsol_sea, wri_fder_ice, wri_evap_ice
+!ym  REAL, DIMENSION(iim, jjm+1) :: wri_evap_sea, wri_rcoa, wri_rriv
+!ym  REAL, DIMENSION(iim, jjm+1) :: wri_rain, wri_snow, wri_taux, wri_tauy
+!ym  REAL, DIMENSION(iim, jjm+1) :: wri_calv
+!ym  REAL, DIMENSION(iim, jjm+1) :: wri_tauxx, wri_tauyy, wri_tauzz
+!ym  REAL, DIMENSION(iim, jjm+1) :: tmp_lon, tmp_lat
+
+  real, dimension(iim, jjphy_nb) :: wri_sol_ice, wri_sol_sea, wri_nsol_ice 
+  real, dimension(iim, jjphy_nb) :: wri_nsol_sea, wri_fder_ice, wri_evap_ice
+  REAL, DIMENSION(iim, jjphy_nb) :: wri_evap_sea, wri_rcoa, wri_rriv
+  REAL, DIMENSION(iim, jjphy_nb) :: wri_rain, wri_snow, wri_taux, wri_tauy
+  REAL, DIMENSION(iim, jjphy_nb) :: wri_calv
+  REAL, DIMENSION(iim, jjphy_nb) :: wri_tauxx, wri_tauyy, wri_tauzz
+  REAL, DIMENSION(iim, jjphy_nb) :: tmp_lon, tmp_lat
+  REAL, DIMENSION(iim, jjphy_nb) :: wri_windsp
+
 ! variables relues par le coupleur
 ! read_sic = fraction de glace
@@ -1581,8 +1793,8 @@
 ! l'avoir lu
   real, allocatable,dimension(:,:),save :: pctsrf_sav
-  real, dimension(iim, jjm+1, 2) :: tamp_srf
+  real, dimension(iim, jjphy_nb, 3) :: tamp_srf
   integer, allocatable, dimension(:), save :: tamp_ind
   real, allocatable, dimension(:,:),save :: tamp_zmasq
-  real, dimension(iim, jjm+1) :: deno
+  real, dimension(iim, jjphy_nb) :: deno
   integer                     :: idtime
   integer, allocatable,dimension(:),save :: unity
@@ -1603,8 +1815,20 @@
   integer :: nb_interf_cpl
 ! -- LOOP
+
+  real :: Up,Down
+  integer :: ierr
+  integer :: il_time_secs
+  real :: tmp_field(klon)
+  
 #include "param_cou.h"
 #include "inc_cpl.h"
 #include "temps.inc"
 #include "iniprint.h"
+
+#ifdef CPP_PARA
+  include 'mpif.h'
+  integer :: status(MPI_STATUS_SIZE)
+#endif
+
 !
 ! Initialisation
@@ -1643,13 +1867,25 @@
 ! -- LOOP
     allocate(cpl_tauy(klon,2), stat = error); sum_error = sum_error + error
-    ALLOCATE(cpl_rriv(iim,jjm+1), stat=error); sum_error = sum_error + error
-    ALLOCATE(cpl_rcoa(iim,jjm+1), stat=error); sum_error = sum_error + error
-    ALLOCATE(cpl_rlic(iim,jjm+1), stat=error); sum_error = sum_error + error
+!ym    ALLOCATE(cpl_rriv(iim,jjm+1), stat=error); sum_error = sum_error + error
+!ym    ALLOCATE(cpl_rcoa(iim,jjm+1), stat=error); sum_error = sum_error + error
+!ym    ALLOCATE(cpl_rlic(iim,jjm+1), stat=error); sum_error = sum_error + error
+    ALLOCATE(cpl_rriv(iim,jjphy_nb), stat=error); sum_error = sum_error + error
+    ALLOCATE(cpl_rcoa(iim,jjphy_nb), stat=error); sum_error = sum_error + error
+    ALLOCATE(cpl_rlic(iim,jjphy_nb), stat=error); sum_error = sum_error + error
+
+
 !!
-    allocate(read_sst(iim, jjm+1), stat = error); sum_error = sum_error + error
-    allocate(read_sic(iim, jjm+1), stat = error); sum_error = sum_error + error
-    allocate(read_sit(iim, jjm+1), stat = error); sum_error = sum_error + error
-    allocate(read_alb_sic(iim, jjm+1), stat = error); sum_error = sum_error + error
-
+!ym    allocate(read_sst(iim, jjm+1), stat = error); sum_error = sum_error + error
+!ym    allocate(read_sic(iim, jjm+1), stat = error); sum_error = sum_error + error
+!ym    allocate(read_sit(iim, jjm+1), stat = error); sum_error = sum_error + error
+!ym    allocate(read_alb_sic(iim, jjm+1), stat = error); sum_error = sum_error + error
+    allocate(read_sst(iim, jjphy_nb), stat = error); sum_error = sum_error + error
+    allocate(read_sic(iim, jjphy_nb), stat = error); sum_error = sum_error + error
+    allocate(read_sit(iim, jjphy_nb), stat = error); sum_error = sum_error + error
+    allocate(read_alb_sic(iim, jjphy_nb), stat = error); sum_error = sum_error + error
+    read_sst=0.
+    read_sic=0.
+    read_sit=0.
+    read_alb_sic=0.
     if (sum_error /= 0) then
       abort_message='Pb allocation variables couplees'
@@ -1665,9 +1901,12 @@
     sum_error = 0
     allocate(tamp_ind(klon), stat = error); sum_error = sum_error + error
-    allocate(tamp_zmasq(iim, jjm+1), stat = error); sum_error = sum_error + error    
+!ym    allocate(tamp_zmasq(iim, jjm+1), stat = error); sum_error = sum_error + error    
+    allocate(tamp_zmasq(iim, jjphy_nb), stat = error); sum_error = sum_error + error    
+    tamp_zmasq=1.
+    
     do ig = 1, klon
       tamp_ind(ig) = ig
     enddo
-    call gath2cpl(zmasq, tamp_zmasq, klon, klon, iim, jjm, tamp_ind)
+    call gath2cpl(zmasq, tamp_zmasq, klon, klon, iim, jjphy_nb, tamp_ind)
 !
 ! initialisation couplage
@@ -1676,6 +1915,10 @@
 #ifdef CPP_COUPLE
 #ifdef CPP_PSMILE
-    CALL inicma(iim, (jjm+1))
+   CALL inicma(iim, (jjm+1))
 #else
+   if (.not. monocpu) then
+      abort_message='coupleur parallele uniquement avec PSMILE'
+      call abort_gcm(modname,abort_message,1)
+   endif
    call inicma(npas , nexca, idtime,(jjm+1)*iim)
 #endif
@@ -1684,4 +1927,6 @@
 ! initialisation sorties netcdf
 !
+ !ym  IO de check deconnecte pour le moment en //
+    IF (monocpu) THEN
     idayref = day_ini
     CALL ymds2ju(annee_ref, 1, idayref, 0.0, zjulian)
@@ -1722,16 +1967,20 @@
     CALL histsync(nidcs)
 
+    ENDIF    ! monocpu
+    
 ! pour simuler la fonte des glaciers antarctiques
 ! 
-    surf_maille = (4. * rpi * ra**2) / (iim * (jjm +1))
-    ALLOCATE(coeff_iceberg(iim,jjm+1), stat=error)
-    if (error /= 0) then
-      abort_message='Pb allocation variable coeff_iceberg'
-      call abort_gcm(modname,abort_message,1)
-    endif
-    open (12,file='flux_iceberg',form='formatted',status='old')
-    read (12,*) coeff_iceberg
-    close (12)
-    num_antarctic = max(1, count(coeff_iceberg > 0))
+!ym => pour le moment, c'est en commentaire, donc je squizze
+
+!ym    surf_maille = (4. * rpi * ra**2) / (iim * (jjm +1))
+!ym    ALLOCATE(coeff_iceberg(iim,jjm+1), stat=error)
+!ym    if (error /= 0) then
+!ym      abort_message='Pb allocation variable coeff_iceberg'
+!ym      call abort_gcm(modname,abort_message,1)
+!ym    endif
+!ym    open (12,file='flux_iceberg',form='formatted',status='old')
+!ym    read (12,*) coeff_iceberg
+!ym    close (12)
+!ym    num_antarctic = max(1, count(coeff_iceberg > 0))
     
     first_appel = .false.
@@ -1800,7 +2049,12 @@
 #ifdef CPP_PSMILE
       il_time_secs=(itime-1)*dtime
-      CALL fromcpl(il_time_secs, iim, (jjm+1),                           &
+      CALL fromcpl(il_time_secs, iim, jjphy_nb,                           &
      &        read_sst, read_sic, read_sit, read_alb_sic)
 #else
+     if (.not. monocpu) then
+        abort_message='coupleur parallele uniquement avec PSMILE'
+        call abort_gcm(modname,abort_message,1)
+     endif
+
       call fromcpl(itime-1,(jjm+1)*iim,                                  &
      &        read_sst, read_sic, read_sit, read_alb_sic)
@@ -1810,15 +2064,18 @@
 ! sorties NETCDF des champs recus
 !
-      ndexcs(:)=0
-      itau_w = itau_phy + itime
-      CALL histwrite(nidcs,cl_read(1),itau_w,read_sst,iim*(jjm+1),ndexcs)
-      CALL histwrite(nidcs,cl_read(2),itau_w,read_sic,iim*(jjm+1),ndexcs)
-      CALL histwrite(nidcs,cl_read(3),itau_w,read_alb_sic,iim*(jjm+1),ndexcs)
-      CALL histwrite(nidcs,cl_read(4),itau_w,read_sit,iim*(jjm+1),ndexcs)
-      CALL histsync(nidcs)
+     if (monocpu) THEN
+       ndexcs(:)=0
+       itau_w = itau_phy + itime
+       CALL histwrite(nidcs,cl_read(1),itau_w,read_sst,iim*(jjm+1),ndexcs)
+       CALL histwrite(nidcs,cl_read(2),itau_w,read_sic,iim*(jjm+1),ndexcs)
+       CALL histwrite(nidcs,cl_read(3),itau_w,read_alb_sic,iim*(jjm+1),ndexcs)
+       CALL histwrite(nidcs,cl_read(4),itau_w,read_sit,iim*(jjm+1),ndexcs)
+       CALL histsync(nidcs)
+     endif
 ! pas utile      IF (npas-itime.LT.nexca )CALL histclo(nidcs)
 
-      do j = 1, jjm + 1
-        do ig = 1, iim
+!ym      do j = 1, jjm + 1
+       do j = 1, jjphy_nb
+         do ig = 1, iim
           if (abs(1. - read_sic(ig,j)) < 0.00001) then
             read_sst(ig,j) = RTT - 1.8
